

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class BitsNumber
 */
@WebServlet("/show-me-the-bits")
public class BitsNumber extends HttpServlet {
	private static final long serialVersionUID = 1L;
  
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		// TODO Auto-generated method stub
		//generamos un PrintWriter para escribir en la pagina web
		PrintWriter pr = new PrintWriter(resp.getOutputStream());
		//generamos una cadena que indicara el error en caso de que pase
		String pgError = "<body><h1>El valor de n es invalido, ingrese un numero de 0 a 65535</h1></body>";
		try {
			if(req.getParameter("n")!=null ) {
				int n = parseDecimal(req.getParameter("n"));
				//si no ocurrio ningun error entonces procedemos a realizar la conversion a bits
				if(n>65535 || n<0) {
					pr.write(pgError);
				}else {
					int [] numero = new int[16];
					
					int aux=n;
					for (int i = 0; n>0; i++) {
						//si el resto al dividir por 2 es cero entonces cargamos 
						if(n%2==0) {
							numero[i] = 0;
						}else
							numero[i]= 1;
						n/=2;
					}
					String num="";
					for (int i = 15; i >-1; i--) {
						if(i==7)
							num+=" === ";
						num+="|"+numero[i];
					}
					//dibujamos el html
					pr.write("<html>"
							+ "<body style=' text-align:center'><h1>Los bits del numero   "+aux+" son:</h1>"
							+"<p style='font-size:5em'>"+num+"</p>"
							+"</body>"
							+ "</html>");
				}
			}else {
				pr.write(pgError);
			}
			
		} catch (Exception e) {
			pr.write(pgError);
		}
		
		pr.close();
	}

	public static int parseDecimal(String nro) throws  IOException{
			//primero vemos si es un numero hexadecimal
			nro = nro.toLowerCase();
			int n=0;
			if(nro.length()>2 && (nro.substring(0, 2)).equals("0x") ) {
				//convertimos el numero a decimal
				nro = nro.substring(2);
				n=Integer.parseInt(nro, 16);
			}else if((nro.substring(0,1)).equals("0")) {
				//es un numero en base 8
				n = Integer.parseInt(nro,8);
			}else {
				//esta en formato decimal
				n =  Integer.parseInt(nro);
			}
		return n;
	}

}
